.intel_syntax noprefix

.global sse_init
sse_init:
  //; Enable bits 9 and 10 in cr4
  //; 9: Enable SSE instructions
  //; 10: Enable SSE exceptions
  mov rax, cr4
  or rax, 1<<9 | 1<<10
  mov cr4, rax

  //; Set bit 1 and unset bit 2 in cr0
  //; 1: Coprocessor monitoring
  //; 2: Coprocessor emulation
  mov rax, cr0
  or rax, 1<<1
  and rax, ~(1<<2)
  mov cr0, rax

  ret

.global sse_save
sse_save:
  fxsave [rdi]
  ret

.global sse_restore
sse_restore:
  fxrstor [rdi]
  ret
